#coding=utf-8

import subprocess
import datetime
import os
import time
import shlex
import serial
from serial.tools import list_ports
from time import sleep

tool = 'esptool'
#BOOTLOADER = 'firmware/optiboot_atmega328.hex'
TEST_PROGRAM2 = 'boot_app0.bin'
TEST_PROGRAM0 = 'ESP32S3_TestandUser_Firmware.ino.bootloader.bin'
TEST_PROGRAM3 = 'ESP32S3_TestandUser_Firmware.ino.bin'
TEST_PROGRAM1 = 'ESP32S3_TestandUser_Firmware.ino.partitions.bin'

def timeout_command(command, timeout=10):
    """
    call shell-command and either return its output or kill it
    if it doesn't normally exit within timeout seconds and return None
    """

    if type(command) == type(''):
        command = shlex.split(command)
    start = datetime.datetime.now()
    process = subprocess.Popen(command)  # , stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    resultcode = process.poll()
    while resultcode is None:
        now = datetime.datetime.now()
        if (now - start).seconds > timeout:
            process.kill()
            return -1
        sleep(0.01)
        resultcode = process.poll()
    return resultcode

def find_device():
    timeout = 30
    while timeout != 0:
        port = None
        for p in list_ports.comports():
            print p[2]
            if p[2].upper().startswith('USB VID:PID=303A:1001'):
                port = p[0]
                print('find port: ' + port)
                return port

            if p[2].upper().startswith('USB VID:PID=303A:1001'):
                port = p[0]
                os.system("MODE %s:1200,N,8,1" %port)
                time.sleep(1)
            

        sleep(0.1)
        timeout -= 1

    print('No test board found')
    return None

def write_test():
    print('Write  test program to test board')
    sleep(0.1)
    port = find_device()
    if not port:
        return -1

    #cmd = '%s -i -d --port=%s -U true -i -e -w -v %s -R' % (tool, port, TEST_PROGRAM)
    cmd = '%s --chip esp32s3 --port=%s --baud 921600 --before default_reset --after hard_reset write_flash -z --flash_mode dio --flash_freq 80m --flash_size 8MB 0x0 %s 0x8000 %s 0xe000 %s  0x10000 %s ' % (tool,port,TEST_PROGRAM0,TEST_PROGRAM1,TEST_PROGRAM2,TEST_PROGRAM3)
    return timeout_command(cmd)


port=find_device()
write_test()  


